//
//  LCOpenApiErrorCode.h
//  LeChangeDemo
//
//  Created by yyg on 2023/2/22.
//  Copyright © 2023 dahua. All rights reserved.
//

#ifndef LCOpenApiErrorCode_h
#define LCOpenApiErrorCode_h


//0         操作成功
//OP1001    操作失败
//OP1002    参数缺失，请确认参数是否有缺失    请求体中，有必填项在params中不存在
//OP1003    参数取值不合法(参数格式有误或为空)，请修正参数值    1.请求体中，有必填项为空（""或null）；2.有传参与协议规定的参数类型不符；3.有传参格式不符合合法值描述
//OP1004    请求内容为空    请求内容为空
//OP1005    无效的请求URL    无效的请求URL
//OP1006    SDK异常    1.SDK调用时，请求体中head为空；2.head中有字段缺失；3.head中有字段为空
//OP1007    无效的方法调用    1.外部接口调用时，system.appId为空（""或null）；2.非用户模块接口调用时，params.token不存在或params.token为空（""或null）
//OP1008    appId为空    system.appId值不符合规范
//OP1009    权限不足，无法执行此操作    设备未被当前用户绑定
//OP1010    应用被冻结    当前App状态为冻结中
//OP1011    当天调用接口次数已达上限    非发布状态的app调用接口是否超出限制
//OP1012    调用接口权限不足    调用接口权限不足
//OP1013    调用接口次数超出限制(总数)    对一些有总调用次数限制的接口，如果开发者调用超过配置的次数限制，会返回此错误码
//OP1014    调用接口次数超出限制（每天）    针对一些每天有总调用次数限制的接口，如果开发者调用超过配置的次数限制，会返回此错误码
//OP1015    权限不足，无法执行此操作。(该设备不是开放平台绑定设备)    权限不足，无法执行此操作。(该设备不是开放平台绑定设备)
//OP1016    请求的设备相关接口达到限制。    开发者每周可操作的设备通道数不能超过当前开发者购买的设备接入数
//OP1019    此时间段无录像产生    此时间段无录像产生
//OP1021    获取播放地址失败    获取播放地址失败
//OP1023    kitToken已过期，请重新获取    kitToken已过期，请重新获取
//OP1026    请求太频繁，请稍候再试。    同一用户同时请求同一个获取token相关接口时，极少数情况下会出现此错误码
//SN1001    签名异常    请求体中，system.sign的取值与OpenApi计算的签名值不一致
//SN1002    签名超时    请求体中，system.time的取值与OpenApi服务器时差 > 5min
//SN1003    签名参数错误    请求体中，system.time不是数值（含字母或特殊字符）
//SN1004    非法的appid    非法的appId
//SN1005    重复的nonce    重复的nonce。开发者向开放平台调用接口时传入的nonce5分钟内不能重复，否则会返回此错误码
//TK1001    该账户（phone）对应的用户与您的应用已绑定
//TK1002    token已过期或不存在，请重新获取token    token已过期或不存在，请重新获取token
//TK1003    非法token，请传入正确的token    非法token，请传入正确的token
//TK1004    当前用户的手机号码还未跟您的应用绑定    请先进行“用户绑定”先进行用户绑定的操作
//TK1005    绑定用户数量超出限制    非发布状态的app绑定用户数量超出限制
//TK1006    当前手机号码不是开发者账号的手机号码，开发者创建应用后，在开放平台网站>开发中心>应用详情页中可以找到管理员账号一项。
//TK2001    失效的csrfToken
//DV1001    设备已被其他账号绑定
//DV1002    设备不存在
//DV1003    设备已被当前账号绑定
//DV1004    更新通道名称失败
//DV1005    设备验证码错误
//DV1006    无需更新设备，设备已是最新版本
//DV1007    设备离线
//DV1008    绑定设备数量超出限制，请先解绑其他冗余设备    非发布状态的app绑定设备数量超出限制。
//DV1009    设备正忙，请稍后再试    需要操作的设备正在处理前一请求
//DV1010    图请求过于频繁，请稍后再试    抓图接口调用过于频繁，1s内同一设备抓图请求多次
//DV1011    设备未添加，请先绑定设备    需要操作的设备并未被当前账号添加
//DV1012    权限不足，该设备属于被授权（或被共享）设备
//DV1013    设备注册3天后绑定,客户端与设备必须在同一个局域网内，设备断电重启下即可再次绑定。
//DV1014    设备绑定错误一分钟超过20次，限制绑定30分钟
//DV1015    设备绑定错误一小时超过60次，限制绑定24小时
//DV1016    设备密码错误。
//DV1018    设备注册到平台，超过三天未绑定，需在局域网内绑定，或重启设备后进行绑定    设备注册到平台后，超过三天未绑定
//DV1019    设备能力集不支持此操作
//DV1020    设备通道离线。
//DV1021    设备异常。
//DV1022    收藏点个数超出限制
//DV1023    收藏点已存在
//DV1024    收藏点不存在
//DV1025    设备SC码或设备密码错误
//DV1026    该设备不支持此功能的调用
//DV1027    设备安全码错误
//DV1028    用户未绑定该设备或设备通道号不存在
//DV1029    设备已经被绑定
//DV1030    设备休眠中
//DV1031    低电量拒绝升级(带电池设备)
//DV1032    设备已被本人锁定
//DV1033    设备已被他人绑定
//DV1034    设备未初始化
//DV1035    设备初始化失败
//DV1036    注销失败，设备未离线达5分钟
//DV1037    NB设备的imei和device id 不匹配
//DV1038    低电量时无法添加临时秘钥
//DV1039    临时密钥生成不满足条件
//DV1040    设备已被绑定失败20次 限制绑定24小时
//DV1041    转移设备数量超过设定的最大值
//DV1042    设备密码错误达限制次数，设备锁定
//DV1043    项目属性不支持
//DV1044    设备IP不在统一局域网内
//DV1045    设备冲突
//DV1047    设备已经自定义加密
//DV1049    设备无存储介质
//DV1050    临时秘钥生成次数超限制
//DV1051    人脸库不存在
//DV1052    添加超过人脸库的上限
//DV1053    抓图失败，请检查网络    调用手动抓图接口时，设备由于网络原因等没有及时返回图片。
//DV1054    新密码组成不符合规则，请按接口详情中密码规则进行修改
//DV1055    设备未通过开放平台绑定
//DV1056    此设备通道号已经分享给开发者，无需再次分享给开发者
//DV1057    通道不存在
//DV1058    您的账号为行业超级管理员账号，并且目前存在分享的设备，故无法解绑此设备
//DV1059    设备在ONENET平台已存在（被第三方绑定）
//DV1060    设备存储介质异常
//DV1061    设备响应超时，请检查设备网络
//DV1062    设备无心跳保持，需要在设备侧进行唤醒操作
//DV1063    设备铃声使用中，不能删除
//DV1064    iot设备绑定随机码错误
//DV1065    不支持手动添加子设备    在添加Iot设备的时候，如果是子设备（配件）的时候不支持直接通过接口添加
//DV1066    设备升级中，不支持此时操作    设备升级中不支持其他操作
//DV1067    不支持P2P设备添加
//DV1068    拒绝访问    wifi异常，不支持访问
//DV1069    不满足操作条件
//DV1070    正在被接听
//DV1080    补光中,不支持白光灯警戒
//DV1081    语音对讲中,不支持开启警笛
//WF1001    请求超时    连接wifi超时
//WF1002    wifi密码错误    连接wifi时，请求体中params.password有误
//SM1001    验证码输入错误    1.绑定用户时，params.smsCode填写有误；2.绑定用户时，验证码以过期。
//SM1002    验证码已过期，请重新获取验证码
//SM1003    服务器处理错误
//SM1004    发送验证码短信失败
//SM1005    当天获取短信验证码次数已达上限    1.非发布状态的app绑定用户时，获取短信验证码次数超出限制；2.发布状态的app绑定用户时，获取短信验证码次数超出限制；
//SM1006    短信发送过于频繁，请稍后再试    获取短信接口调用过于频繁
//SMS01    短信发送次数超出限制
//SMS02    短信发送次数超出限制
//TH1001    当前方法有误，不是透传接口方法
//TH1003    消息回调URL格式有误
//ST1001    当前设备默认云存储套餐已到期，操作失败    开启默认云存储套餐时，默认套餐已过期
//ST1002    当前设备无默认云存储套餐，操作失败
//ST1003    当前使用的云存储套餐不是默认云存储套餐，操作失败
//ST1004    云存储套餐未开通
//ST1005    云存储套餐已过期
//ST1006    云存储套餐不存在
//ST1007    调用开通云存储接口次数不足一次
//ST1008    当前设备使用的定时录像计划用云存储套餐使用中，需暂停
//ST1009    操作失败，当前设备仍有未过期的收费云存储套餐策略。
//ST1010    该设备不支持对应云存储套餐策略
//RC1001    云录像未找到    根据云录像片段信息查询云录像不存在
//LV1001    该视频直播已存在    绑定直播地址接口调用时，当前设备、rtsp地址源已有直播地址绑定
//LV1002    该视频直播不存在
//LV1004    设备已经自定义加密密钥    开启直播计划时，流量不足
//LV1005    直播信息不存在。
//LV1006    操作失败，同一rtsp源地址同一天内仅能被绑定1次。
//LV1008    创建直播需要实名认证，请前往开放平台网站-基本信息页完善信息，如是个人用户请上传本人身份证，如果是公司客户请上传营业执照以及其他
//LV1020    已绑定直播,无法删除
//YL1001    定时拉取模式下，拉取的时间点不能在定时录像计划时间内。
//YL1002    定时计划时间参数重合，重合时间为XX-XX。
//YL1003    操作失败，存在有效的云存储录像计划，请关闭云存储录像计划后重试。
//YL1004    操作失败，存在有效的动检计划，请关闭动检计划后重试。
//YL1005    操作失败，请开通支持设置云存储录像计划的云存储策略套餐。
//GT1001    授权角色已经存在
//GT1002    添加角色失败
//GT1003    用户授权已经存在
//GT1004    创建用户授权失败
//GT1005    用户授权不存在
//GT1006    角色不存在
//GT1007    角色为默认角色
//GT1008    授权超过限制
//GT1009    不能授权给自己
//GT1010    获取授权列表失败
//GT1011    获取权限列表所传参数有误
//GP1001    设备分组名称已经存在
//GP1002    设备分组Id不存在
//GP1003    设备已被添加至分组
//US1001    用户不存在
//US1002    该用户不存在这个授权关系
//P2P001    P2P鉴权接口，鉴权ID 已过期
//P2P002    P2P鉴权接口，头部域参数缺失
//P2P003    token过期
//P2P004    没有设备权限
//AD1001    未绑定综治员
//LD1001    设备本地无存储介质
//AP1001    配件不存在
//AP1002    配件离线
//FL1001    开发者剩余接入数不足    开发者可以通过登录开放平台网站，点击"已购资源"查看剩余的设备通道接入数
//FL1002    开发者当前无可用带宽    音视频预览时（实时预览、录像回放），系统检测到开发者无剩余流量，并且也未购买带宽，则返回错误信息。开发者可以通过登录开放平台网站，点击"已购资源"查看剩余流量和可用带宽。
//FL1003    开发者当前使用带宽超过额度限制    音视频预览时（实时预览、录像回放），系统检测到开发者的带宽使用超过限额，则返回错误信息。开发者可以通过登录开放平台网站，点击"控制台-我的资源 (opens new window)"查看剩余流量和可用带宽。
//FL1004    开发者剩余流量不足    音视频预览时（实时预览、录像回放），系统检测到开发者无剩余流量，并且也未购买带宽，则返回错误信息。开发者可以通过登录开放平台网站，点击"已购资源"查看剩余流量和可用带宽
//FL1005    开发者音视频取流操作时没有可用带宽且剩余流量不足    音视频预览时（实时预览、录像回放），系统检测到开发者无剩余流量，并且也未购买带宽，则返回错误信息。开发者可以通过登录开放平台网站，点击"已购资源"查看剩余流量和可用带宽。
//PF1001    repositoryToken不存在
//PF1002    faceToken不存在
//PF1003    未检测到人脸
//PF1004    暂不支持该功能
//PF1005    图片大小超过2M限制
//PF1006    type类型不匹配
//PF1007    获取特征值失败，请先进行图片检测
//UR1000    用户未登陆
//UR1001    不支持邮箱登陆
//PH1001    修改手机号频次已达上限
//ST1011    调用接口次数超过限制，同一个套餐24小时内只能解绑一次
//ST1012    免费云存储不支持解绑
//SUB1000    子账号无法进行此操作
//SUB1001    当前子账号无指定权限，无法操作
//SUB1002    子账号无设备任意权限，无法操作
//SUB1005    子账号token过期
//SUB1006    子账号与设备无授权关系
//SUB1007    创建子账号失败
//SUB1008    子账号与当前应用无绑定关系
//SUB1009    子账号创建失败，账号格式错误    仅支持手机号或者邮箱作为子账号
//SUB1010    子账号创建失败，账号已存在    重复绑定子账号到应用下

#endif /* LCOpenApiErrorCode_h */
